% function analysisCrossValidation
clear
t_95margin_df4 = 2.78;

%% Plotting the AUC comparisons
nF_basis = 40;
nF_localmean = 8;

% run 21~25: 5 positive training examples
count = 1; 
auc5_activebasis = zeros(1,5);
auc5_localmeanGabor17 = zeros(1,5);
auc5_combined = zeros(1,5);
auc5_adaboostMax = zeros(1,5);
auc5_activebasisAdapt =zeros(1,5);
for iRun = 21:25
    load(sprintf('sigmoid/out_run%d.mat',iRun),'testAUC');
    auc5_activebasis(count) = testAUC(end);
    load(sprintf('sigmoidLocalMeanWithNegGabor17/out_run%d.mat',iRun),'testAUC');
    auc5_localmeanGabor17(count) = testAUC(nF_localmean);
    load(sprintf('sigmoidLocalMeanWithNegGabor17/combinedWithSigmoid_run%d.mat',iRun),'testAUC');
    auc5_combined(count) = testAUC(end);
    load(sprintf('adaboostMax/out_adaboostMax_run%d.mat',iRun),'testAUC');
    auc5_adaboostMax(count) = testAUC(end);
    load(sprintf('sigmoidAdaptive/out_run%d.mat',iRun),'testAUC');
    auc5_activebasisAdapt(count) = testAUC(nF_basis);
    count = count + 1;
end

% run 16~20: 80 positive training examples
count = 1; 
auc80_activebasis = zeros(1,5);
auc80_localmeanGabor17 = zeros(1,5);
auc80_combined = zeros(1,5);
auc80_adaboostMax = zeros(1,5);
auc80_activebasisAdapt =zeros(1,5);
for iRun = 16:20
    load(sprintf('sigmoid/out_run%d.mat',iRun),'testAUC');
    auc80_activebasis(count) = testAUC(end);
    load(sprintf('sigmoidLocalMeanWithNegGabor17/out_run%d.mat',iRun),'testAUC');
    auc80_localmeanGabor17(count) = testAUC(nF_localmean);
    load(sprintf('sigmoidLocalMeanWithNegGabor17/combinedWithSigmoid_run%d.mat',iRun),'testAUC');
    auc80_combined(count) = testAUC(end);
    load(sprintf('adaboostMax/out_adaboostMax_run%d.mat',iRun),'testAUC');
    auc80_adaboostMax(count) = testAUC(end);
    load(sprintf('sigmoidAdaptive/out_run%d.mat',iRun),'testAUC');
    auc80_activebasisAdapt(count) = testAUC(nF_basis);
    count = count + 1;
end

% run 11~15: 40 positive training examples
count = 1; 
auc40_adaboost = zeros(1,5);
auc40_activebasis = zeros(1,5);
auc40_localmeanGabor17 = zeros(1,5);
auc40_combined = zeros(1,5);
auc40_adaboostMax = zeros(1,5);
auc40_activebasisAdapt =zeros(1,5);
for iRun = 11:15
    load(sprintf('sigmoid/out_run%d.mat',iRun),'testAUC');
    auc40_activebasis(count) = testAUC(end);
    load(sprintf('sigmoidLocalMeanWithNegGabor17/out_run%d.mat',iRun),'testAUC');
    auc40_localmeanGabor17(count) = testAUC(nF_localmean);
    load(sprintf('sigmoidLocalMeanWithNegGabor17/combinedWithSigmoid_run%d.mat',iRun),'testAUC');
    auc40_combined(count) = testAUC(end);
    load(sprintf('adaboostMax/out_adaboostMax_run%d.mat',iRun),'testAUC');
    auc40_adaboostMax(count) = testAUC(end);
    load(sprintf('sigmoidAdaptive/out_run%d.mat',iRun),'testAUC');
    auc40_activebasisAdapt(count) = testAUC(nF_basis);
    count = count + 1;
end

% run 6~10: 20 positive training examples
count = 1; 
auc20_adaboost = zeros(1,5);
auc20_activebasis = zeros(1,5);
auc20_localmeanGabor17 = zeros(1,5);
auc20_combined = zeros(1,5);
auc20_adaboostMax = zeros(1,5);
auc20_activebasisAdapt =zeros(1,5);
for iRun = 6:10
    load(sprintf('sigmoid/out_run%d.mat',iRun),'testAUC');
    auc20_activebasis(count) = testAUC(end);
    load(sprintf('sigmoidLocalMeanWithNegGabor17/out_run%d.mat',iRun),'testAUC');
    auc20_localmeanGabor17(count) = testAUC(nF_localmean);
    load(sprintf('sigmoidLocalMeanWithNegGabor17/combinedWithSigmoid_run%d.mat',iRun),'testAUC');
    auc20_combined(count) = testAUC(end);
    load(sprintf('adaboostMax/out_adaboostMax_run%d.mat',iRun),'testAUC');
    auc20_adaboostMax(count) = testAUC(end);
    load(sprintf('sigmoidAdaptive/out_run%d.mat',iRun),'testAUC');
    auc20_activebasisAdapt(count) = testAUC(nF_basis);
    count = count + 1;
end

% run 1~5: 10 positive training examples
count = 1; 
auc10_adaboost = zeros(1,5);
auc10_activebasis = zeros(1,5);
auc10_combined = zeros(1,5);
auc10_localmeanGabor17 = zeros(1,5);
auc10_adaboostMax = zeros(1,5);
auc10_activebasisAdapt =zeros(1,5);
for iRun = 1:5
    load(sprintf('sigmoid/out_run%d.mat',iRun),'testAUC');
    auc10_activebasis(count) = testAUC(end);
    load(sprintf('sigmoidLocalMeanWithNegGabor17/out_run%d.mat',iRun),'testAUC');
    auc10_localmeanGabor17(count) = testAUC(nF_localmean);
    load(sprintf('sigmoidLocalMeanWithNegGabor17/combinedWithSigmoid_run%d.mat',iRun),'testAUC');
    auc10_combined(count) = testAUC(end);
    load(sprintf('adaboostMax/out_adaboostMax_run%d.mat',iRun),'testAUC');
    auc10_adaboostMax(count) = testAUC(end);
    load(sprintf('sigmoidAdaptive/out_run%d.mat',iRun),'testAUC');
    auc10_activebasisAdapt(count) = testAUC(nF_basis);
    count = count + 1;
end

curve1 = [mean(auc5_activebasis), mean(auc10_activebasis), mean(auc20_activebasis), mean(auc40_activebasis), mean(auc80_activebasis)];
err1 = [std(auc5_activebasis), std(auc10_activebasis), std(auc20_activebasis), std(auc40_activebasis), std(auc80_activebasis)];

curve3 = [mean(auc5_localmeanGabor17), mean(auc10_localmeanGabor17), mean(auc20_localmeanGabor17), mean(auc40_localmeanGabor17), mean(auc80_localmeanGabor17)];
err3 = [std(auc5_localmeanGabor17), std(auc10_localmeanGabor17), std(auc20_localmeanGabor17), std(auc40_localmeanGabor17), std(auc80_localmeanGabor17)];
curve4 = [mean(auc5_combined), mean(auc10_combined), mean(auc20_combined), mean(auc40_combined), mean(auc80_combined)];
err4 = [std(auc5_combined), std(auc10_combined), std(auc20_combined), std(auc40_combined), std(auc80_combined)];
curve5 = [mean(auc5_activebasisAdapt), mean(auc10_activebasisAdapt), mean(auc20_activebasisAdapt), mean(auc40_activebasisAdapt), mean(auc80_activebasisAdapt)];
err5 = [std(auc5_activebasisAdapt), std(auc10_activebasisAdapt), std(auc20_activebasisAdapt), std(auc40_activebasisAdapt), std(auc80_activebasisAdapt)];

% Plot the three curves of Test AUC
%   with 95% confidence bounds
figure;
hold on;
plot([5,10,20,40,80],curve5+t_95margin_df4*err5/sqrt(5),'b:','LineWidth',2);
h5 = plot([5,10,20,40,80],curve5,'b-s','LineWidth',3);
plot([5,10,20,40,80],curve5-t_95margin_df4*err5/sqrt(5),'b:','LineWidth',2);
plot([5,10,20,40,80],curve3+t_95margin_df4*err3/sqrt(5),'k:','LineWidth',2);
h3 = plot([5,10,20,40,80],curve3,'k-','LineWidth',3);
plot([5,10,20,40,80],curve3-t_95margin_df4*err3/sqrt(5),'k:','LineWidth',2);
plot([5,10,20,40,80],curve4+t_95margin_df4*err4/sqrt(5),'r:','LineWidth',2);
h4 = plot([5,10,20,40,80],curve4,'r-.','LineWidth',3);
plot([5,10,20,40,80],curve4-t_95margin_df4*err4/sqrt(5),'r:','LineWidth',2);

set(gca,'FontSize',12);
set(gca,'ylim',[0.82 1]);
set(get(gca,'XLabel'),'String','# training positives','FontSize',18);
set(get(gca,'YLabel'),'String','testing AUC','FontSize',18);
legend([h5 h3 h4],{'Active Basis Adaptive','local mean with neg','combined'},'Location','SouthEast','FontSize',20);
title('AUC vs. the number of positive training examples','FontSize',18);
set(gcf, 'PaperPositionMode', 'auto');
print -depsc compare_localMeanWithNegGabor17.eps
print -dpng compare_localMeanWithNegGabor17.png

% Another plotting method: plot lines with error bars
% errorbar([10,20,40],curve1,err1,'LineWidth',3); hold on
% errorbar([10,20,40],curve2,err2,'+-r','LineWidth',3);
% errorbar([10,20,40],curve3,err3,'--k','LineWidth',3);

% plot only the mean AUC (without the error bounds)
% figure;
% hold on;
% plot([5,10,20,40,80],curve5,'b-s','LineWidth',3);
% plot([5,10,20,40,80],curve3,'k-','LineWidth',3);
% plot([5,10,20,40,80],curve4,'r-.','LineWidth',3);
% set(gcf, 'PaperPositionMode', 'auto');
% set(gca,'FontSize',12);
% set(gca,'ylim',[0.6 1]);
% set(get(gca,'XLabel'),'String','# training positives','FontSize',18);
% set(get(gca,'YLabel'),'String','testing AUC','FontSize',18);
% legend({'Active Basis Adaptive','PCA','Adaboost on MAX1'},'Location','SouthEast','FontSize',20);
% title('AUC vs. the number of positive training examples','FontSize',18);
% print -depsc compare2.eps
% print -dpng auc_comparison_mean.png





